#include "rtmp_api.h"

void *rtmp_pci_alloc_consistent(struct pci_dev *hwdev, size_t size, dma_addr_t *dma_handle)
{
    return (pci_alloc_consistent(hwdev, size, dma_handle));
}

void rtmp_pci_free_consistent(struct pci_dev *hwdev, size_t size, void *vaddr, dma_addr_t dma_handle)
{
    return (pci_free_consistent(hwdev, size, vaddr, dma_handle));
}

void rtmp_dev_kfree_skb_any(struct sk_buff *skb)
{
    dev_kfree_skb_any(skb);
}

struct file *rtmp_filp_open(const char *src, int flag, int mode)
{
    return (filp_open(src, flag, mode));
}

int rtmp_filp_close(struct file *file, fl_owner_t id)
{
    return (filp_close(file, id));
}

int rtmp_isxdigit(unsigned char ch)
{
    return (isxdigit(ch));
}

long rtmp_simple_strtol(const char *cp,char **endp,unsigned int base)
{
    if(*cp=='-')
        return (-simple_strtoul(cp+1,endp,base));
    return (simple_strtoul(cp,endp,base));
}

char *rtmp_strstr(const char * s1,const char * s2)
{
    return (strstr(s1, s2));
}

void rtmp_init_timer(struct timer_list **timer)
{
    *timer = kmalloc(sizeof(struct timer_list), GFP_KERNEL);
    init_timer(*timer);
}

int  rtmp_del_timer_sync(struct timer_list * timer)
{
    return (del_timer_sync(timer));
}

unsigned long rtmp_get_jiffies(void )
{
    return (jiffies);
}

void *rtmp_kmalloc(size_t size, int type)
{
    return (kmalloc(size, type));
}

void rtmp_add_timer(struct timer_list *timer)
{
    add_timer(timer);
}

void rtmp_kfree(const void *ptr)
{
    kfree(ptr);
}

struct sk_buff *rtmp_dev_alloc_skb(unsigned int length) 
{
    return (dev_alloc_skb(length));
}

int rtmp_netif_rx(struct sk_buff *skb)
{
    return (netif_rx(skb));
}

unsigned short rtmp_eth_type_trans(struct sk_buff *skb, struct net_device *dev)
{
    return (eth_type_trans(skb, dev));
}

unsigned char *rtmp_skb_put(struct sk_buff *skb, unsigned int len) 
{
    return (skb_put(skb, len));
}

void rtmp_udelay(int delaytime)
{
    udelay(delaytime);
}

int rtmp_in_interrupt(void)
{
    int __cpu;

    __cpu = smp_processor_id();

    return ((local_irq_count(__cpu) + local_bh_count(__cpu)) != 0);
}

void rtmp_writel(unsigned long b, unsigned long addr)
{
    *(volatile unsigned int *) __io_virt(addr) = (b);
}

unsigned long rtmp_readl(unsigned long addr)
{
    return (*(volatile unsigned int *) __io_virt(addr));
}

char *rtmp_getprofilepath(void)
{
    char *ptr;

    ptr = (char *) kmalloc(sizeof(PROFILE_PATH) + 1, GFP_KERNEL);
    if (ptr == NULL)
    {
        DBGPRINT(RT_DEBUG_TRACE, "out of memory for allocating PROFILE_PATH");
        return NULL;
    }
    memcpy(ptr, PROFILE_PATH, sizeof(PROFILE_PATH));
    
    return ptr;
}

