#ifndef __RTMP_API_H__
#define __RTMP_API_H__
#include "rt_config.h"

void *rtmp_pci_alloc_consistent(struct pci_dev *hwdev, size_t size, dma_addr_t *dma_handle);
void rtmp_pci_free_consistent(struct pci_dev *hwdev, size_t size, void *vaddr, dma_addr_t dma_handle);
void rtmp_dev_kfree_skb_any(struct sk_buff *skb); 
struct file *rtmp_filp_open(const char *src, int flag, int mode);
int rtmp_filp_close(struct file *file, fl_owner_t id);
int rtmp_isxdigit(unsigned char ch);
long rtmp_simple_strtol(const char *cp,char **endp,unsigned int base);
char *rtmp_strstr(const char * s1,const char * s2);
void rtmp_init_timer(struct timer_list **timer);
int  rtmp_del_timer_sync(struct timer_list * timer); 
unsigned long rtmp_get_jiffies(void );  
void *rtmp_kmalloc(size_t size, int type);  
void rtmp_add_timer(struct timer_list *timer); 
void rtmp_kfree(const void *ptr); 
struct sk_buff *rtmp_dev_alloc_skb(unsigned int length); 
int rtmp_netif_rx(struct sk_buff *skb);
unsigned short rtmp_eth_type_trans(struct sk_buff *skb, struct net_device *dev);
unsigned char *rtmp_skb_put(struct sk_buff *skb, unsigned int len); 
void rtmp_udelay(int delaytime);
int rtmp_in_interrupt(void);
void rtmp_writel(unsigned long b, unsigned long addr);
char *rtmp_getprofilepath(void);
unsigned long rtmp_readl(unsigned long addr);
#endif  // __RTMP_API_H__

