#ifndef APCONFIG_H
#define APCONFIG_H

#include <qvariant.h>
#include <qdialog.h>
#include "rt_tool.h"
#include "qhexvalidator.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QCheckBox;
class QComboBox;
class QFrame;
class QGroupBox;
class QLabel;
class QLineEdit;
class QButtonGroup;
class QRadioButton;
//class QListBox;
//class QListBoxItem;
class QListView;
class QListViewItem;
class QProgressBar;
class QPushButton;
class QTabWidget;
class QWidget;
class QSpinBox;

class AuthSecuDlg;
class QHexValidator;

class ApConfigForm : public QWidget
{ 
    Q_OBJECT

public:
    ApConfigForm( int socket_id, const char *device_name, QWidget *parent = 0, const char *name = 0 );
    ~ApConfigForm();

    QTabWidget* TabWidgetApConfigForm;
//ConfigPage
    QWidget* tabConfigPage;
    QLabel* TextLabelSsid;   
    QFrame* Line1;
    QLineEdit* LineEditSsid;            //SSID
    QPushButton* PushButtonUseMacAddress;
    QPushButton* PushButtonSecurity;
    QLabel* TextLabelMode;
    QComboBox* ComboBoxMode;            //Wireless mode
    QLabel* TextLabel3;
    QComboBox* ComboBoxTxRate;          //TxRate
    QLabel* TextLabel4;
    QComboBox* ComboBoxChannel;         //Channel
    QLabel* TextLabel8;
    QLabel* TextLabel9;
    QLabel* TextLabel10;
    QLabel* TextLabel11;
    QComboBox* ComboBoxBGProtection;    //m_nBGProtection
    QLabel* TextLabel5;
    QComboBox* ComboBoxTXPreamble;      //m_nTXPreamble
    QSpinBox* SpinBoxBeaconPeriod;      //m_nBeaconPeriod
    QSpinBox* SpinBoxRtsThreshold;      //m_nRtsThreshold
    QSpinBox* SpinBoxFragThreshold;     //m_nFragThreshold
    QPushButton* PushButtonDefault;     //Button Default
    QPushButton* PushButtonApply;       //Button Apply
    QCheckBox* CheckBoxShortSlot;       //m_bShortSlot
    QCheckBox* CheckBoxHideSSID;        //m_bHideSSID
    QCheckBox* CheckBoxNoForwarding;    //m_bNoForwarding
    QCheckBox* CheckBoxTurboRate;       //m_bTurboRate
    QCheckBox* CheckBoxTXBurst;         //m_bTXBurst
    QCheckBox* CheckBoxAutoSelChannel;  //m_bAutoChanSel
//AccessControlPage
    QWidget* tabAccessControlPage;
    QListView* ListViewAccessControl;
    QLabel* TextLabel14;
    QComboBox* ComboBoxAccessPolicy;    //m_nAccessPolicy
    QLineEdit* LineEditMacAddress;      //m_strMacAddress
    QPushButton* AccessPushButtonAdd;
    QPushButton* AccessPushButtonRemoveAll;
    QPushButton* AccessPushButtonDelete;
    QPushButton* AccessPushButtonApplyNow;
    QLabel* TextLabel12;
    QLabel* TextLabel13;
//WdsPage
    QWidget* tabWdsPage;
    QButtonGroup* ButtonGroupWds;
    QLabel* TextLabelWdsPolicy;
    QRadioButton* RadioButtonWdsEnable;
    QRadioButton* RadioButtonWdsDisable;
    QLineEdit* LineEditWdsMacAddress;
    QPushButton* WdsPushButtonDelete;
    QLabel* TextLabelWdsState;
    QLabel* TextLabelWdsMacAddress;
    QLabel* TextLabelDumbApList;
    QListView* ListViewWds;
    QPushButton* WdsPushButtonAdd;
    QPushButton* WdsPushButtonRemoveAll;
    QPushButton* WdsPushButtonApply;
//MacTabelPage
    QWidget* tabMacTablePage;
    QListView* ListViewMacTable;
//EventLogPage
    QWidget* tabEventLogPage;
    QListView* ListViewEventLog;
    QPushButton* EventPushButtonClear;
//StatisticsPage
    QWidget* tabStatisticsPage;
    QPushButton* StatisticsPushButtonReset;
    QGroupBox* GroupBox1;
    QLabel* TextLabel43;
    QLabel* TextLabel42;
    QLabel* TextLabel41;
    QLabel* TextLabel40;
    QLabel* TextLabel39;
    QLabel* TextLabel38;
    QGroupBox* GroupBox2;
    QLabel* TextLabel31;
    QLabel* TextLabel30;
    QLabel* TextLabel29;
    QLabel* TextLabel28;
    QLabel* TextLabelEqlsign1;
    QLabel* TranSucFrameLable;
    QLabel* TextLabelEqlsign2;
    QLabel* TranSucWithoutRetryLabel;
    QLabel* TextLabelEqlsign3;
    QLabel* TranSucAftRetryLabel;
    QLabel* TextLabelEqlsign4;
    QLabel* TranFailAckLabel;
    QLabel* TextLabelEqlsign5;
    QLabel* TranSucRTSLabel;
    QLabel* TextLabelEqlsign6;
    QLabel* TranFailRTSLabel;
    QLabel* TextLabelEqlsign7;
    QLabel* RcvSucFrameLabel;
    QLabel* TextLabelEqlsign8;
    QLabel* RcvCRCErrLabel;
    QLabel* TextLabelEqlsign9;
    QLabel* RcvDropFrameLabel;
    QLabel* TextLabelEqlsign10;
    QLabel* RcvDupFrameLabel;
//AboutPage
    QWidget* tabAboutPage;
    QGroupBox* GroupBox4;
    QLabel* TextLabel36;
    QLabel* TextLabel35;
    QGroupBox* GroupBox5;
    QLabel* TextLabel37;
    QGroupBox* GroupBox3;
    QLabel* TextLabel34;
    QLabel* TextLabel33;
    QLabel* TextLabel1_2;
    QLabel* UtilityDateTextLabel;
    QLabel* UtilityVersionTextLabel;
    QLabel* NicVersionTextLabel;
    QLabel* NicDateTextLabel;
    QLabel* MacTextLabel;

    QHexValidator  *hexValidator;

    QString m_strSSID;
    QString m_strChannel;
    QString m_strMacAddress;
    UCHAR m_chAryChan52Ghz[32];
    UCHAR m_chAryChan24Ghz[32];

    int     m_nSocket_Id;
    char    *m_strDevice_Name;
    int     m_nWirelessMode;
    int     m_nTXRate;
    int     m_nTXAntenna;
    int     m_nRXAntenna;
    int     m_nTXPreamble;
    int     m_nBGProtection;
    int     m_bTXBurst;
    int     m_bTurboRate;
    int     m_bNoForwarding;
    int     m_bHideSSID;
    int     m_bShortSlot;
    int     m_bAutoChanSel;
    int     m_n24GhzIndex;
    int     m_n52GhzIndex;

    UINT    m_nRtsThreshold;
    UINT    m_nBeaconPeriod;
    UINT    m_nFragThreshold;
    ULONG   m_lTxCount;
    ULONG   m_lRxCount;
    AuthSecuDlg* m_pdlgAuthSecu;
    int     timerId_alive;
    int     timerId_getMacTable;
    int     timerId_getEventLog;
    int     timerId_getStatistics;

    bool    ConfigPage_WriteConfigToRegistryAndSetOid();
    void    ConfigPage_OnSelchangeWirelessMode();

    bool    AccessControlPage_WriteConfigToRegistryAndSetOid();
    bool    WdsPage_WriteConfigToRegistryAndSetOid();

    void    WdsPage_OnActive();
    void    WdsPage_EnableControl(bool bEnable);
    void    MacTablePage_OnActive();
    void    MacTablePage_GetMacTable();
    void    EventLogPage_OnActive();
    void    EventLogPage_GetEvent();
    void    StatisticsPage_OnActive();
    void    StatisticsPage_GetStatistics();
    void    AboutPage_OnActive();
    void    GetCountryChannel();
    int     G_nEventRead;
    QValueList   <RT_802_11_EVENT_LOG> G_aryEventLog;

public slots:
    virtual void noThingh() { };
    virtual void ConfigPage_OnApplyNow();
    virtual void ConfigPage_OnSecurity();
    virtual void ConfigPage_OnDefault();
    virtual void ConfigPage_OnUseMacAddress();
    virtual void ConfigPage_ComboBoxMode_activated(int);
    virtual void OnPageChanged();
    virtual void AccessControlPage_OnApplyNow();
    virtual void AccessControlPage_OnAdd();
    virtual void AccessControlPage_OnDelete();
    virtual void AccessControlPage_OnRemoveAll();
    virtual void AccessControlPage_OnSelchangeAccessPolicy(int);
    virtual void WdsPage_ButtonGroupWds_Click(int);
    virtual void WdsPage_OnApplyNow();
    virtual void WdsPage_OnAdd();
    virtual void WdsPage_OnDelete();
    virtual void WdsPage_OnRemoveAll();
    virtual void EventLogPage_OnClear();
    virtual void StatisticsPage_OnResetCounters();
    virtual void timerEvent(QTimerEvent* e);
};

#endif // APCONFIG_H
